package com.javacodegeeks.mockito;

import org.testng.annotations.Test;

import com.javacodegeeks.mockito.EngineerAware.Engineer;

import static org.mockito.Mockito.*;
import static org.testng.Assert.*;

public class SpyOnInterfaceExample {
	@Test
	public void spyOnInterface() {
		EngineerAware engineerAware = spy(new Dev());
		assertEquals(Engineer.DEV, engineerAware.getDesignation());
		when(engineerAware.getDesignation()).thenReturn(Engineer.QA);
		assertEquals(Engineer.QA, engineerAware.getDesignation());
	}	
	private class Dev implements EngineerAware {
		@Override
		public Engineer getDesignation() {
			return Engineer.DEV;
		}
		
	}
}
